<?php
namespace Academico\Entities;

use \Geral\Entities\Prospect;
use \Geral\Entities\Municipio;

/** @method static findByOneCdprospectAndNrorg($prospect, $nrorg) */
class Endeprospect extends Base\Endeprospect
{

    const PRINCIPAL = 'P';
    const COBRANCA = 'C';
    const EXTERIOR = 'E';
    const EXPORTACAO = 'X';
    const ENTREGA = 'T';
    const OUTROS = 'O';


    public function insereEndereco($nrorg, $prospect,$pais,$estado,$municipio,$dtInclusao,$operador){
        /** @var $objProspect \Geral\Entities\Prospect */

        $objProspect = \Geral\Entities\Prospect::getObject(array('cdprospect' => $prospect, 'nrorg' => $nrorg));
        /** @var $objMunicipio \Geral\Entities\Municipio */
        $objMunicipio = \Geral\Entities\Municipio::getObjectByWhere(
            "CDPAIS = :CDPAIS AND SGESTADO = :SGESTADO AND CDMUNICIPIO = :CDMUNICIPIO AND NRORG = :NRORG",
            array(
                ':CDPAIS'       => $pais,
                ':SGESTADO'     => $estado,
                ':CDMUNICIPIO'  => $municipio,
                ':NRORG'        => $nrorg
            )
        );

        $this->setProspect($objProspect);
        $this->setIdtpendepros(self::PRINCIPAL);
        $this->setMunicipio($objMunicipio);
        $this->setDtinclusao($dtInclusao);
        $this->setCdoperinclusao($operador);

        $this->persist();
    }

}