<?php
namespace Relatione\Logic;

use \Relatione\Logic\ContatoLogic;

use \Geral\Entities\Parceria;
use \Geral\Logic\ParceiroNegocio\Parcnegocio;
use \Geral\Util\TratamentoDeMensagens;
use \Geral\Entities\Parcnegocio  as ParcnegocioEntity;
use \Setforms2\Runtime\Framework;
use \Relatione\Logic\ProspectLogic;
use \Geral\Util\Ambiente;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;

class FundirParceirosLogic{

	public static function tratarFusao($opcao,$valor=null,$tipo=null)
	{
		if ($opcao == 'sim')
		{
			if ($tipo == 'CANDIDATO') 
			{
				$sql = 'SELECT CAND.*
						  FROM CRM_CANDIDATO CAND, PARCNEGOCIO PARC
						 WHERE CAND.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
						   AND CAND.NRCANDIDATO = :NRCANDIDATO
						   AND PARC.CDTIPOPARCPRINCIPAL <> \'CANDIDATO\'';
				$aux = array('NRCANDIDATO' => $valor);
				$retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $aux);
				if (count($retorno)>0) 
				{
					$valor = $retorno[0]['NRPARCNEGOCIO'];
				}
			}
			$params = array('VALOR'=>$valor,'VALIDACAO'=>true,'TIPO'=>$tipo);
			tk_set_env_var('FUNDIR',$params);
			//tk_var_dump($params);
			tk_open_window('Zd_Crm00007000_Popup',true);
		}
		else
		{
			$params = array('VALOR'=>null,'VALIDACAO'=>false, 'TIPO'=>$tipo);
			tk_set_env_var('FUNDIR',$params);
			//tk_var_dump($params);
			tk_open_window('Zd_Crm00007000_Popup',true);
		}
	}
	
	public static function validaFusao()
	{
		$tipo = tk_get_field_value('TIPOPARC');
		$codigo = tk_get_field_value('PARCCAND');

		if (($tipo=='CANDIDATO')&&($codigo!=null)) 
		{
			$sql = 'SELECT * FROM CRM_CANDIDATO WHERE NRCANDIDATO = :NRCANDIDATO';
			$aux = array('NRCANDIDATO' => $codigo);
			$retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $aux);
			if ($retorno[0]['NRPARCNEGOCIO']==null) 
			{
				$dtinclusao = $retorno[0]['DTINCLUSAO'];
        		$dtinclusao = \Geral\Util\DateUtil::getDataDeString($dtinclusao,\Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
				if($retorno[0]['IDTPIJURCAN'] != null)
			        { 
			          $incri = $retorno[0]['IDTPIJURCAN'];
			          switch($incri)
			          {
			            case 'J': $idInscrica = 'CNPJ';
			                      break;
			            case 'F': $idInscrica = 'CPF';
			                      break;
			            default: $idInscrica = 'LIVRE';
			          }
			        }

			    else
			        {
			          $idInscrica = 'LIVRE';
			          $incri = 'I';
			        }

			    $nrContato = $retorno[0]['NRCONTATO'];
			    $cdFilial = '9999';
			    $nrParcNegocio = $retorno[0]['NRPARCNEGOCIO'];

			    try
			        {
			          @self::newParc($retorno[0]['NRORG'], $retorno[0]['NMCANDIDATO'], $retorno[0]['NMFANTCAN'], $retorno[0]['NRINSJURCAN'], $nrParcNegocio, $retorno[0]['CDSEGMER'], $idInscrica, $dtinclusao, $retorno[0]['NRCANDIDATO'], $incri);
			          @self::newContato($nrContato, $cdFilial, $retorno[0]['NRORG'], $dtinclusao, tk_get_env_var('PARCNEGO'), $retorno[0]['NRCANDIDATO']);
			        }
			    catch(\Exception $e){
			          tk_warning($e->getMessage());
			        }
			    return tk_get_env_var('PARCNEGO');
			}
			else
			{
				return tk_get_field_value('NRPARCNEGOCIO');
			}
		}
		else
		{
			return tk_get_field_value('NRPARCNEGOCIO');
		}
	}
	
	public static function newParc($nrOrg, $nmPrincipalParc, $nmSecundariParc, $nrInscricaoParc, $nrParcNegocio, $cdSegMer, $idInscrica, $dtinclusao, $nrCandidato, $incri)
    {
            if($nrParcNegocio==NULL)
      {         
                $nrParcNegocio = Parcnegocio::geraNovoCodigoParcNegocio();
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                try {
                    $parceiro = new ParcnegocioEntity;
                    $parceiro->setNrorg($nrOrg);
                    $parceiro->setNmprincipalparc($nmPrincipalParc);
                    $parceiro->setNmsecundariparc($nmSecundariParc);
                    $parceiro->setNrinscricaoparc($nrInscricaoParc);
                    $parceiro->setNrparcnegocio($nrParcNegocio);
                    if($cdSegMer != null)
                      {$parceiro->setCdsegmer($cdSegMer);}
                    $parceiro->setCdtipoparcprincipal('CANDIDATO');
                    $parceiro->setCdtipoinscricao($idInscrica);
                    $parceiro->setIdativo(\Geral\Entities\Parcnegocio::IDATIVO_SIM);
                    $parceiro->setIdpessoafisica(\Geral\Entities\Parcnegocio::IDPESSOAFISICA_NAO);
                    $parceiro->setIdinstituicao(\Geral\Entities\Parcnegocio::IDINSTITUICAO_NAO);
                    $parceiro->setDtinclusao($dtinclusao);
                    $parceiro->setCdoperinclusao(\Geral\Util\Ambiente::getCdoperador());
                    $parceiro->setNrorginclusao(\Geral\Util\Ambiente::getNrorg());
                    $parceiro->setIdparcfundido('N');
                    $parceiro->persist();
                    $connection->flush();
                    $count = true;
                } catch (\Exception $e) {
                    throw $e;
                }
            //}
              
            $nrParceiroNegocio = $parceiro->getNrparcnegocio();
            $nrparceiro = \Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(),'PARCERIA');
        $parceria = Parceria::findOneByNrparcnegocioAndCdtipoparceiroAndNrorg($nrParceiroNegocio, 'LIVRE', $nrOrg);
        if ($parceria === null) {
            try {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $parceria = new Parceria;
                $parceria->setNrparceria($nrparceiro);
                $parceria->setNrorg($nrOrg);
                $parceria->setNrparcnegocio($nrParceiroNegocio);
                $parceria->setCdtipoparceiro('CANDIDATO');
                $parceria->setIdativo('S');
                $parceria->setDtinclusao($dtinclusao);
                $parceiro->setCdoperinclusao(\Geral\Util\Ambiente::getCdoperador());
                $parceiro->setNrorginclusao(\Geral\Util\Ambiente::getNrorg());
                $parceria->persist();
                $connection->flush();
            } catch (\Exception $e) {
                throw $e;
            }
        }
        $paramsUpd = array('NRPARCNEGOCIO'=>$nrParcNegocio,
                          'NRINSJURCAN'=>$nrInscricaoParc,
                          'IDTPIJURCAN'=>$incri,
                          'NRORG'=>$nrOrg,
                          'NRCANDIDATO'=>$nrCandidato);
        @self::UpdateNrparc($paramsUpd);
          tk_set_env_var('COUNT',true);
      }//end if
      tk_set_env_var('PARCNEGO',$nrParcNegocio);
    }

  public static function newContato($nrOrg, $nrParcNegocio, $nrsequencial, $table)
    {
      if(tk_get_field_value('NRSEQCONTATO') == null)
      {   

        $idstatuscont = 'A';
        $idtpcontato = 'P';
        $cdopercont = \Geral\Util\Ambiente::getCdOperador();
        $idativo  = 'S';

        if($table=='CRM_CANDIDATO')
        {
          $dsrefecont = 'Referente ao lead '.tk_get_field_value('NMCANDIDATO');
        }  
        elseif ($table=='CRM_OPORTUNI') 
        {
          $dsrefecont = 'Referente a oportunidade '.tk_get_field_value('NMOPORT');
        }

        $prospect = ContatoLogic::retornaProspect($nrOrg, $nrParcNegocio);

        $cliente = ContatoLogic::retornaCliente($nrOrg, $nrParcNegocio);

        $fornecedor = ContatoLogic::retornaFornecedor($nrOrg, $nrParcNegocio);

        if(($dsrefecont!=NULL)&&($nrParcNegocio!=NULL))  
        {

          $contatos = \Services\Logic\GeraContatoLogic::geracaoContatoLogic(null,$cliente,NULL,substr($dsrefecont, 0, 59),$idstatuscont,$fornecedor,$prospect,$idtpcontato,NULL,NULL,NULL,NULL,NULL,$cdopercont,NULL,NULL,NULL,NULL,NULL,$nrOrg,NULL,NULL,NULL,$nrParcNegocio,$idativo);

          if($table=='CRM_CANDIDATO')
          {
            $paramsUpd2 = array('NRSEQCONTATO'=>$contatos['NRSEQCONTATO'],
                                'NRCONTATO'=>$contatos['NRCONTATO'],
                                'CDFILIAL'=>'9999',
                                'NRORG'=>$nrOrg,
                                'NRSEQUENCIAL_PARAM'=>$nrsequencial);
            $paramsUpd3 = array('TABLE'=>$table,'NRSEQUENCIAL'=>'NRCANDIDATO');
          }  
          elseif ($table=='CRM_OPORTUNI') 
          {
            $paramsUpd2 = array('NRSEQCONTATO'=>$contatos['NRSEQCONTATO'],
                                'NRCONTATO'=>$contatos['NRCONTATO'],
                                'CDFILIAL'=>'9999',
                                'NRORG'=>$nrOrg,
                                'NRSEQUENCIAL_PARAM'=>$nrsequencial);
            $paramsUpd3 = array('TABLE'=>$table,'NRSEQUENCIAL'=>'NRSEQOPORT');
          }
          tk_set_field_value('NRCONTATO',$contatos['NRCONTATO']);
          tk_set_field_value('CDFILIAL','9999');
          tk_set_field_value('NRSEQCONTATO',$contatos['NRSEQCONTATO']);
            
          @self::UpdateNrcontato($paramsUpd2,$paramsUpd3);
          tk_set_env_var('COUNT',true);
        }
      }

    }

  public static function UpdateNrparc($paramsUpd){
      $sql = "
              UPDATE CRM_CANDIDATO 
                 SET NRPARCNEGOCIO = :NRPARCNEGOCIO, NRINSJURCAN = :NRINSJURCAN, IDTPIJURCAN = :IDTPIJURCAN
               WHERE NRORG = :NRORG
                 AND NRCANDIDATO = :NRCANDIDATO";
      
      $aux = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $paramsUpd);
    
  }

  public static function UpdateNrcontato($paramsUpd2,$paramsUpd3){
      $sql = "
              UPDATE ".$paramsUpd3['TABLE']." 
                 SET NRSEQCONTATO = :NRSEQCONTATO,
                     NRCONTATO = :NRCONTATO,
                     CDFILIAL = :CDFILIAL                 
               WHERE NRORG = :NRORG
                 AND ".$paramsUpd3['NRSEQUENCIAL']." = :NRSEQUENCIAL_PARAM";
        
      $aux = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $paramsUpd2);
    
  }
  //Update o parceiro do contato se este ja tiver um.
  public static function updateContato($contatoUpd)
  {
  	$sql = 'UPDATE CONTATO
  			   SET NRPARCNEGOCIO = :NRPARCNEGOCIO
  			 WHERE NRSEQCONTATO = :NRSEQCONTATO';
  	\Setforms2\Runtime\Connection::getInstance()->execute($sql, $contatoUpd);
  }

// Faz a chamada da procedure FUNDIR_PARCNEGOCIO_CRM, e recebe como parametro o(s) código(s) do(s) parceiro(s) de origem e o código do parceiro de origem
  public static function chamaProcedureFundir($nrparcnegorigem, $nrparcnegdestino)
  { 
    try
    {
          $procedure = new Procedure("FUNDIR_PARCNEGOCIO_CRM");
          
      $procedure->addParam(
                      new Param(
                              'P_PARCNEGORIGEM',
                              Param::PARAM_INPUT,
                              $nrparcnegorigem,
                              Param::PARAM_TYPE_STR
                           )
                    );
          $procedure->addParam(
                      new Param(
                              'P_PARCNEGDESTINO',
                              Param::PARAM_INPUT,
                              $nrparcnegdestino,
                              Param::PARAM_TYPE_INT
                           )
                    );
          $procedure->addParam(
                  new Param(
                        'P_NRORG',
                        Param::PARAM_INPUT,
                        \Geral\Util\Ambiente::getNrorg(),
                        Param::PARAM_TYPE_INT
                       )
                    );
          $procedure->addParam(
                  new Param(
                        'P_CDOPERULTATU',
                        Param::PARAM_INPUT,
                        \Geral\Util\Ambiente::getCdoperador(),
                        Param::PARAM_TYPE_STR
                       )
                    );
          $procedure->addParam(
                      new Param(
                              'P_RETORNO',
                              Param::PARAM_OUTPUT,
                              NULL,
                              Param::PARAM_TYPE_STR,
                              10
                             )
                    );
          $procedure->addParam(
                      new Param(
                              'P_RETORNOERRO',
                              Param::PARAM_OUTPUT,
                              NULL,
                              Param::PARAM_TYPE_STR,
                              550
                             )
                    );

          $entrada = $procedure->call();
          return $entrada;
      }
      catch (\Exception $e){
          throw $e;
      }
  }


}