package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AnaliseRestricoesContratuaisFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.AnaliseRestricoesContratuaisPage;
import org.testng.annotations.Test;

public class AnaliseRestricoesContratuaisTests extends TestBase {

    AnaliseRestricoesContratuaisPage analiseRestricoesContratuaisPage;
    AnaliseRestricoesContratuaisFlows analiseRestricoesContratuaisFlows;
    LoginFlows loginFlows;

//      Frequência de Grupo de Pratos Analítico (Mês)
//      Frequência de Grupo de Pratos Sintético (Mês)
//      Frequência de Grupo de Pratos Analítico (Semana)
//      Frequência de Grupo de Pratos Sintético (Semana)
//      Limite Per Capita por Serviço Analítico
//      Limite Per Capita por Serviço Sintético
//      Frequência de Produtos por Grupo de Prato Analítico (Mês)
//      Frequência de Produtos por Grupo de Prato Sintético (Mês)
//      Frequência de Produtos por Grupo de Prato Analítico (Semana)
//      Frequência de Produtos por Grupo de Prato Sintético (Semana)
//      Frequência de Pratos Analítico (Mês)
//      Frequência de Pratos Sintético (Mês)
//      Frequência de Pratos Analítico (Semana)
//      Frequência de Pratos Sintético (Semana)
//      Frequência de Opções por Grupo de Prato Analítico (Mês)
//      Frequência de Opções por Grupo de Prato Sintético (Mês)
//      Frequência de Opções por Grupo de Prato Analítico (Semana)
//      Restrições de Produtos por Grupo de Prato Analítico
//      Restrições de Produtos por Grupo de Prato Sintético

    @Test
    public void relatorioGrupoPratoAnaliticoMes() {
        emitiRelatorio("Frequência de Grupo de Pratos Analítico (Mês)", "Contrato");
    }

    @Test
    public void relatorioGrupoPratoSinteticoMes() {
        emitiRelatorio("Frequência de Grupo de Pratos Sintético (Mês)", "Contrato");
    }

    @Test
    public void relatorioGrupoPratoAnaliticoSemana() {
        emitiRelatorio("Frequência de Grupo de Pratos Analítico (Semana)", "Contrato");
    }

    @Test
    public void relatorioGrupoPratoSinteticoSemana() {
        emitiRelatorio("Frequência de Grupo de Pratos Sintético (Semana)", "Contrato");
    }

    @Test
    public void relatorioLimiteServicoAnalitico() {
        emitiRelatorio("Limite Per Capita por Serviço Analítico", "Contrato");
    }

    @Test
    public void relatorioLimiteServicoSintetico() {
        emitiRelatorio("Limite Per Capita por Serviço Sintético", "Contrato");
    }

    @Test
    public void relatorioProdutoGrupoPratoAnaliticoMes() {
        emitiRelatorio("Frequência de Produtos por Grupo de Prato Analítico (Mês)", "Contrato");
    }

    @Test
    public void relatorioProdutoGrupoPratoSinteticoMes() {
        emitiRelatorio("Frequência de Produtos por Grupo de Prato Sintético (Mês)", "Contrato");
    }

    @Test
    public void relatorioProdutoGrupoPratoAnaliticoSemana() {
        emitiRelatorio("Frequência de Produtos por Grupo de Prato Analítico (Semana)", "Contrato");
    }

    @Test
    public void relatorioProdutoPratoSinteticoSemana() {
        emitiRelatorio("Frequência de Produtos por Grupo de Prato Sintético (Semana)", "Planejado");
    }

    @Test
    public void relatorioPratoAnaliticoMes() {
        emitiRelatorio("Frequência de Pratos Analítico (Mês)", "Planejado");
    }

    @Test
    public void relatorioPratoSinteticoMes() {
        emitiRelatorio("Frequência de Pratos Sintético (Mês)", "Planejado");
    }

    @Test
    public void relatorioPratoAnaliticoSemana() {
        emitiRelatorio("Frequência de Pratos Analítico (Semana)", "Planejado");
    }

    @Test
    public void relatorioPratoSinteticoSemana() {
        emitiRelatorio("Frequência de Pratos Sintético (Semana)", "Planejado");
    }

    @Test
    public void relatorioOpcaoGrupoPratoAnaliticoMes() {
        emitiRelatorio("Frequência de Opções por Grupo de Prato Analítico (Mês)", "Planejado");
    }

    @Test
    public void relatorioOpcaoGrupoPratoSinteticoMes() {
        emitiRelatorio("Frequência de Opções por Grupo de Prato Sintético (Mês)", "Planejado");
    }

    @Test
    public void relatorioOpcaoGrupoPratoAnaliticoSemana() {
        emitiRelatorio("Frequência de Opções por Grupo de Prato Analítico (Semana)", "Planejado");
    }

    @Test
    public void relatoriorestricoesGrupoAnalitico() {
        emitiRelatorio("Restrições de Produtos por Grupo de Prato Analítico", "Planejado");
    }

    @Test
    public void relatorioRestricoesGrupoSintetico() {
        emitiRelatorio("Restrições de Produtos por Grupo de Prato Sintético", "Planejado");
    }

    //selecionar o relatório
    //selecionar o tipo (Contrato ou Planejado)
    //selecionar a unidade jabaquara
    //selecionar o grupo de serviço 'Geral'
    //selecionar os serviços (Retiradas e Jantar)
    //é gerada uma condição para que em alguns relatórios, sejam selecionados os produtos (inicial e final)
    //e também verificar a opção 'Exibe apenas Produtos Divergentes'
    //é gerado o relatórios o mesmo é fechado e retorna à tela anterior
    //é selecionado o agrupamento de unidades (MATERIA PRIMA...)
    //são selecionadas as unidades (jabaquara e deposito BC 129)
    //selecionar os serviços (Retiradas e Jantar)
    //é gerada uma condição para que também sejam selecionados o agrupamento de prato e grupo de prato, desde que o relatório selecionado seja diferente dos citados na condição
    //selecionar o mês de setembro e a ordenação alfabética
    //gerar o relatório
    //atualizar a tela e tentar gerar o relatório com alguns campos vazios e verificar quais deles são obrigatórios
    public void emitiRelatorio(String nomeRelatorio, String tipo) {
        analiseRestricoesContratuaisPage = new AnaliseRestricoesContratuaisPage();
        analiseRestricoesContratuaisFlows = new AnaliseRestricoesContratuaisFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        analiseRestricoesContratuaisFlows.navegateAnaliseRestricoesContratuais();
        analiseRestricoesContratuaisPage.selecionarRelatorio(nomeRelatorio);
        analiseRestricoesContratuaisPage.selecionarTipo(tipo);
        analiseRestricoesContratuaisPage.selecionarUnidades();
        analiseRestricoesContratuaisPage.selecionarGrupoGeral();
        analiseRestricoesContratuaisPage.selecionarServicos();

        if (nomeRelatorio.equals("Limite Per Capita por Serviço Analítico") || nomeRelatorio.equals("Limite Per Capita por Serviço Sintético")
                || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Analítico (Mês)") || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Sintético (Mês)")
                || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Analítico (Semana)") || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Sintético (Semana)")
                || nomeRelatorio.equals("Restrições de Produtos por Grupo de Prato Analítico") || nomeRelatorio.equals("Restrições de Produtos por Grupo de Prato Sintético")) {

            analiseRestricoesContratuaisPage.selecionarProdutos();
            if (!nomeRelatorio.equals("Restrições de Produtos por Grupo de Prato Analítico")
                    && !nomeRelatorio.equals("Restrições de Produtos por Grupo de Prato Sintético")) {
                analiseRestricoesContratuaisPage.verificaProdutosDivergentes();
            }
        }

        analiseRestricoesContratuaisPage.geraRelatorio();
        analiseRestricoesContratuaisPage.selecionarAgrupamentoUnidade();
        analiseRestricoesContratuaisPage.selecionarUnidades();
        analiseRestricoesContratuaisPage.selecionarServicos();

        if (nomeRelatorio != "Frequência de Pratos Analítico (Mês)" && nomeRelatorio != "Frequência de Pratos Sintético (Mês)"
                && nomeRelatorio != "Frequência de Pratos Analítico (Semana)" && nomeRelatorio != "Frequência de Pratos Sintético (Semana)"
                && tipo == "Contrato") {

            analiseRestricoesContratuaisPage.selecionarAgrupamentoPrato();
            analiseRestricoesContratuaisPage.selecionarGrupoPrato();
        }

        analiseRestricoesContratuaisPage.selecionarMesMaio();
        analiseRestricoesContratuaisPage.selecionarOrdencaoAlfabetica();
        analiseRestricoesContratuaisPage.geraRelatorio();
        analiseRestricoesContratuaisPage.refresh();
        analiseRestricoesContratuaisPage.selecionarRelatorio(nomeRelatorio);
        analiseRestricoesContratuaisPage.deixarCampoUnidadeVazio();
        analiseRestricoesContratuaisPage.verficarCamposObrigatorios(nomeRelatorio);
    }

}