package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.EmissaoCardapioMesFlows;
import com.javaseleniumtemplate.pages.EmissaoCardapioMesPage;
import org.testng.annotations.Test;

public class EmissaoCardapioMesTests extends TestBase {

    EmissaoCardapioMesPage emissaoCardapioMesPage;
    EmissaoCardapioMesFlows emissaoCardapioMesFlows;
    LoginFlows loginFlows;

//    relatorioEmissaoCardapioMes = Emissão do Cardápio do Mês
//    relatorioCentralizado = Emissão do Cardápio do Mês (Centralizado)
//    relatorioInativoReceita = Cardápios com Produto Inativo na Receita
//    relatorioInativoReceitaGeral = Cardápios com Produto Inativo na Receita (Geral)
//    relatorioDezColunas = Emissão do Cardápio do Mês (10 Colunas)
//    relatorioCusto = Emissão do Cardápio do Mês (Custo)
//    relatorioCustoTipoPrato = Emissão do Cardápio do Mês (Custo Tipo de Prato)
//    relatorioPeriodoPagina = Emissão do Cardápio do Mês (Período por Página)


    @Test
    public void relatorioEmissaoCardapioMes() {
        gerarRelatorio("Emissão do Cardápio do Mês");
    }

    @Test
    public void relatorioCentralizado() {
        gerarRelatorio("Emissão do Cardápio do Mês (Centralizado)");
    }

    @Test
    public void relatorioInativoReceita() {
        gerarRelatorio("Cardápios com Produto Inativo na Receita");
    }

    @Test
    public void relatorioInativoReceitaGeral() {
        gerarRelatorio("Cardápios com Produto Inativo na Receita (Geral)");
    }

    @Test
    public void relatorioDezColunas() {
        gerarRelatorio("Emissão do Cardápio do Mês (10 Colunas)");
    }

    @Test
    public void relatorioCusto() {
        gerarRelatorio("Emissão do Cardápio do Mês (Custo)");
    }

    @Test
    public void relatorioCustoTipoPrato() {
        gerarRelatorio("Emissão do Cardápio do Mês (Custo Tipo de Prato)");
    }

    @Test
    public void relatorioPeriodoPagina() {
        gerarRelatorio("Emissão do Cardápio do Mês (Período por Página)");
    }

    //gerar relatório com a opção "Todos" unidades e serviços selecionadas
    //gerar relatório com as unidades e serviços selecionados manualmente
    public void gerarRelatorio(String nomeRelatorio) {
        emissaoCardapioMesPage = new EmissaoCardapioMesPage();
        emissaoCardapioMesFlows = new EmissaoCardapioMesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioMesFlows.navegateTelaEmissaoCardapioMes();
        emissaoCardapioMesPage.selecionarRelatorio(nomeRelatorio);

        if (nomeRelatorio == "Emissão do Cardápio do Mês (Custo)" || nomeRelatorio == "Emissão do Cardápio do Mês (Custo Tipo de Prato)") {
            emissaoCardapioMesPage.gerarRelatorio();
            emissaoCardapioMesPage.selecionarUnidadeJabaquara();
        } else {
            emissaoCardapioMesPage.selecionarAgrupamento();
            emissaoCardapioMesPage.gerarRelatorio();
            emissaoCardapioMesPage.selecionarDepositoBc129();
            emissaoCardapioMesPage.selecionarServicos();
        }

        emissaoCardapioMesPage.selecionarMeses();
        emissaoCardapioMesPage.gerarRelatorio();


        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

    }

    //tentar gerar um relatório selecionando o mês inicial maior que o final
    //verificar os campo obrigatórios (unidade, serviço, mês inicial, mês final e tipo de custo)
    //verificar os checkbox de todas as unidades e todos serviços, testar se os mesmos selecionados ou não à medida que clica nos mesmos
    //verificar os checkbox imprimir mensagem, nome fantasia, dias sem cardápio e imprimir
    //verificar as comensais número e percentual, se estes campos ficam habilitados ou não quando o imprimir está selecionado
    @Test
    public void verificarCampos() {
        emissaoCardapioMesPage = new EmissaoCardapioMesPage();
        emissaoCardapioMesFlows = new EmissaoCardapioMesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioMesFlows.navegateTelaEmissaoCardapioMes();
        emissaoCardapioMesPage.selecionarMesesIncorrentos();
        emissaoCardapioMesPage.refresh();
        emissaoCardapioMesPage.campoObrigatorios();
        emissaoCardapioMesPage.verificarCampoObrigatorioTipoCusto();
        emissaoCardapioMesPage.refresh();
        emissaoCardapioMesPage.verificarTodasUnidadeServico();
        emissaoCardapioMesPage.refresh();
        emissaoCardapioMesPage.marcarCheckBoxs();
        emissaoCardapioMesPage.refresh();
        emissaoCardapioMesPage.marcarComensais();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
